local flist = {
version = 81,
dirPaths = {
{name="src/framework"},
{name="src/framework/cc"},
{name="src/framework/cc/components"},
{name="src/framework/cc/components/behavior"},
{name="src/framework/cc/components/ui"},
{name="src/framework/cc/mvc"},
{name="src/framework/cc/net"},
{name="src/framework/cc/sdk"},
{name="src/framework/cc/ui"},
{name="src/framework/cc/uiloader"},
{name="src/framework/cc/utils"},
{name="src/framework/cocos2dx"},
{name="src/framework/deprecated"},
{name="src/framework/platform"},
},
fileInfoList = {
{name="src/framework/anysdkConst.lua",code="05dc6397028645a30db35d051b76bfc9",size=3318},
{name="src/framework/audio.lua",code="34a3802ecfe2a10065a188b2f56fe79d",size=8054},
{name="src/framework/cc/components/behavior/EventProtocol.lua",code="283932d458bc5b2201fabc247a905d6e",size=7426},
{name="src/framework/cc/components/behavior/StateMachine.lua",code="97ee4466ef1e7a23858089245d770def",size=12394},
{name="src/framework/cc/components/Component.lua",code="959b165a6ca2c3f3def6d3c36eecd227",size=2378},
{name="src/framework/cc/components/ui/BasicLayoutProtocol.lua",code="f4bf0421ceb22b56b76654a4ff5e6465",size=5622},
{name="src/framework/cc/components/ui/DraggableProtocol.lua",code="6f6fa14fa42243f21f838f210a557c6b",size=1998},
{name="src/framework/cc/components/ui/LayoutProtocol.lua",code="f0baf6e0f1b079e24399aedc84ab5375",size=1470},
{name="src/framework/cc/EventProxy.lua",code="40f56f55def3528dfdaad66c9fb60f84",size=2810},
{name="src/framework/cc/GameObject.lua",code="9a179f4b35495d5d1acbfd4fb0671b33",size=1210},
{name="src/framework/cc/init.lua",code="d8250d57ac9f1da55cdbcfe25e0b3670",size=1562},
{name="src/framework/cc/mvc/AppBase.lua",code="310ddbebf138e24343862af9d24917bd",size=3046},
{name="src/framework/cc/mvc/init.lua",code="8aff36d68d00cd4721246de4d2b1a8fb",size=242},
{name="src/framework/cc/mvc/ModelBase.lua",code="60d402bf05ef1ae16f9e9e415ce7cf8c",size=3966},
{name="src/framework/cc/net/init.lua",code="cce75f09042138dd1dd3f6e792f58324",size=182},
{name="src/framework/cc/net/SocketTCP.lua",code="bb4c626f32dfcb74298eeac84570bb10",size=9054},
{name="src/framework/cc/Registry.lua",code="55d00b859b61fdff326cc5e7478a9ef0",size=3542},
{name="src/framework/cc/sdk/Store.lua",code="e8b429dfcc360614f1f32122b1821cd0",size=5918},
{name="src/framework/cc/ui/init.lua",code="62826e5c804cc05ad27ccf0f0749b587",size=2190},
{name="src/framework/cc/ui/UIBoxLayout.lua",code="c2222f9fcd3f34d331b468bf346df102",size=6710},
{name="src/framework/cc/ui/UIButton.lua",code="4555e0a2c825a467fac489d40e6fb17a",size=14890},
{name="src/framework/cc/ui/UICheckBoxButton.lua",code="63c1131b99657bfa1ee6f9ee514b6c6b",size=5606},
{name="src/framework/cc/ui/UICheckBoxButtonGroup.lua",code="401ffee4c7e2170e1196cbf1974c6e73",size=4594},
{name="src/framework/cc/ui/UIGroup.lua",code="fc2ff8f7bea7c1cd5daba63cfa3c83bb",size=2570},
{name="src/framework/cc/ui/UIImage.lua",code="3b1580b06d6541495bdef2fc428c9b06",size=2142},
{name="src/framework/cc/ui/UIInput.lua",code="2423eaea5b647fd4c295dcad3386352c",size=3782},
{name="src/framework/cc/ui/UILabel.lua",code="e5a52a675aa1ceadafc7130f1f0ca6aa",size=1602},
{name="src/framework/cc/ui/UILayout.lua",code="14d268d12fa5c3ba8fc725500e78fa00",size=3822},
{name="src/framework/cc/ui/UIListView.lua",code="a0423a06df0b9389488ea9c2f63352c7",size=26862},
{name="src/framework/cc/ui/UIListViewItem.lua",code="2797dfc1321e239df5dd34ded407f8cc",size=3826},
{name="src/framework/cc/ui/UILoadingBar.lua",code="b2ab301d1e32c84e88fb43d9148f9629",size=3190},
{name="src/framework/cc/ui/UIPageView.lua",code="88598c8a4f91141e75d712f72d81223b",size=21190},
{name="src/framework/cc/ui/UIPageViewItem.lua",code="0bbfc3e1e63ac436fae31d9acf146ed3",size=398},
{name="src/framework/cc/ui/UIPushButton.lua",code="f483318d63777200be5d651d6c3068c6",size=3586},
{name="src/framework/cc/ui/UIScrollView.lua",code="9dc75424d359a78e6701b4e2b748e6c9",size=27386},
{name="src/framework/cc/ui/UISlider.lua",code="ddcc71f5d6298f443b842d9a77f32686",size=17034},
{name="src/framework/cc/ui/UIStretch.lua",code="ff3fb6b064769cbf7923e7e3817fcfc9",size=1890},
{name="src/framework/cc/uiloader/CCSSceneLoader.lua",code="d8a1db54f534e34fc677e8bbad023747",size=5482},
{name="src/framework/cc/uiloader/CCSUILoader.lua",code="c76cf84146fa5f752950a5018b5b6c3c",size=37070},
{name="src/framework/cc/uiloader/init.lua",code="8188677a056ea0a25902598e195c92f7",size=158},
{name="src/framework/cc/uiloader/uiloader.lua",code="34c1276bfa06a5f084f1660d6822c0a5",size=5618},
{name="src/framework/cc/uiloader/UILoaderUtilitys.lua",code="96cf65b825203acd074cb89956df5ad7",size=3150},
{name="src/framework/cc/utils/bit.lua",code="7148d78b3f752316491371b19c6f696f",size=6578},
{name="src/framework/cc/utils/ByteArray.lua",code="bedeb5bd79dcc4cd937b10595a8994b8",size=16394},
{name="src/framework/cc/utils/ByteArrayVarint.lua",code="21b8d1daff86417066ce43da7c33c8f6",size=3750},
{name="src/framework/cc/utils/GameState.lua",code="fcb71be403d6c27c08d77dc5ac5d1017",size=6030},
{name="src/framework/cc/utils/Gettext.lua",code="07875280fb80b8d0868ae906519407a2",size=2770},
{name="src/framework/cc/utils/init.lua",code="0af71d0f1de22d24c5b0577c3cf0f280",size=370},
{name="src/framework/cc/utils/Localize.lua",code="b54d81a55f371c9272f73c6edfbf3123",size=1122},
{name="src/framework/cc/utils/Timer.lua",code="c692da3d15e8a9888fa13331f0209843",size=3190},
{name="src/framework/cocos2dx/ActionEx.lua",code="33d05b96df5920c0c7cb8aacf97f630e",size=15850},
{name="src/framework/cocos2dx/Cocos2d.lua",code="be094cd20fe9dd331188afcf9213fc7b",size=17674},
{name="src/framework/cocos2dx/Cocos2dConstants.lua",code="91203bc80177526a379b243ffc642031",size=27742},
{name="src/framework/cocos2dx/DrawNodeEx.lua",code="6ad5f4246de3c01e832bc4da6e96812a",size=1058},
{name="src/framework/cocos2dx/Event.lua",code="1691c9a16fef470091155f5fa259d818",size=470},
{name="src/framework/cocos2dx/NodeEx.lua",code="694737f44490320ba12b03e4387711a1",size=13510},
{name="src/framework/cocos2dx/OpenglConstants.lua",code="18e63fd8a8c2da12c1afb71d5ced5777",size=50498},
{name="src/framework/cocos2dx/SceneEx.lua",code="c51787759735cc7ea1b344c9667fbc05",size=1026},
{name="src/framework/cocos2dx/SpriteEx.lua",code="b359ef275028384c22b131a6ee8cf3b4",size=698},
{name="src/framework/cocos2dx/StudioConstants.lua",code="a62e9aa8f8a012863038a9be96c35610",size=266},
{name="src/framework/cocos2dx.lua",code="5a95bdc23447e3e5b04f3a657d9fb132",size=774},
{name="src/framework/crypto.lua",code="6a13be4c5a9b37944d68e6319ad2e1a2",size=2930},
{name="src/framework/debug.lua",code="d876591ef16a38b0cf578a1a0d040da9",size=5570},
{name="src/framework/deprecated/deprecated_functions.lua",code="f17131d22d59c83b160d16e7cf5b9480",size=286},
{name="src/framework/device.lua",code="91de3e82e0cc601890dc4b1c78fbcb00",size=8102},
{name="src/framework/display.lua",code="03a0045f9bc92e9cd22cb1753f718fa2",size=40442},
{name="src/framework/filter.lua",code="cfd0c7e8d96b0cbd5f8260dced765371",size=3818},
{name="src/framework/functions.lua",code="8437d4d0b1590c57b308e1785b5b1272",size=18434},
{name="src/framework/global.lua",code="3e7f1eab678500da7f672859e9cbf2f4",size=82},
{name="src/framework/init.lua",code="ccd2b97bf461615703ff44a7e8b1544c",size=4102},
{name="src/framework/json.lua",code="16134848ef53eb1d8ad76e90eb72e2ee",size=1198},
{name="src/framework/luaj.lua",code="662b7448878adcff62b6da2d2ab8374f",size=1466},
{name="src/framework/luaoc.lua",code="f4b6bb1c284b747d8c657ba937297529",size=1226},
{name="src/framework/network.lua",code="7723709418278c9e04b40954c726ee0e",size=4414},
{name="src/framework/platform/android.lua",code="522fb3f45171f0eb8a309b7c84224ba3",size=914},
{name="src/framework/platform/ios.lua",code="94acc073722f50a9970c9fda3ce6cffe",size=490},
{name="src/framework/platform/mac.lua",code="698b2481205200927fb5992b0548f012",size=218},
{name="src/framework/scheduler.lua",code="413b17ccf261ac05fbe4e56f09a9ac6c",size=1366},
{name="src/framework/shortcodes.lua",code="eae8ad5a267adc3e2201f1b355f6df70",size=8914},
{name="src/framework/transition.lua",code="aa0ac945ad881d14b3d5cd78c60c2d39",size=11674},
{name="src/framework/ui.lua",code="013fad57242c53ec76c3c106f95777a6",size=3426},
},
fileSize =567782,
}

return flist