--
-- Author: songhua
-- Date: 2015-06-15 17:12:24
--
package.loaded["launcher.init"] = nil
require("launcher.init")

package.loaded["launcher.UpdateMgr"] = nil
package.loaded["launcher.LauncherAssertDialog"] = nil
package.loaded["launcher.HideContentDef"] = nil

local scheduler = require("framework.scheduler")
local LauncherAssertDialog = require("launcher.LauncherAssertDialog") 
local HideContentDef = require("launcher.HideContentDef")
local UpdateMgr = require("launcher.UpdateMgr")
if cc.FileUtils:getInstance():isFileExist("src/launcher/AnySdkChannel.lua") then
    AnySdkChannel = require("launcher.AnySdkChannel")
end
local backGroundName
    if CONFIG_SCREEN_ORIENTATION == "landscape" then -- 横版
        backGroundName = "res/common/bg/dt_hb_bg.jpg"
    else
        backGroundName = "res/common/bg/public_vertical_bg.jpg"
    end
    print("backGroundName = ",backGroundName)
local BitSizeKey = 1024
local _Mainurl = false
local DEFAULT_TIMEOUT = 120
-- 增加背景，进度条，显示百分比
local function enter_game()
    --TODO:这里加载游戏包
    if GAME_RELEASE then
        cc.LuaLoadChunksFromZIP("lib/game.zip")
    end
	Launcher.InitData(Launcher.tData)
	require("app.MyApp").new():run()                                       --#####################################  2执行gamelobby
end

local UpdateScene = lcher_class("UpdateScene", function()
	local scene = cc.Scene:create()
	scene.name = "UpdateScene"
    return scene
end)

function UpdateScene:ctor()
    -- win32平台
    if (Launcher.platform ~= "android" and Launcher.platform ~= "ios") then
        cc.FileUtils:getInstance():addSearchPath(self._path)
        cc.FileUtils:getInstance():addSearchPath("res/")
    end

        cc.FileUtils:getInstance():addSearchPath(Launcher.writablePath .. "upd/" .. "res/")
        cc.FileUtils:getInstance():addSearchPath(Launcher.writablePath .. "upd/" .. "src/launcher")
        cc.FileUtils:getInstance():addSearchPath("res/")
        cc.FileUtils:getInstance():addSearchPath("src/launcher")
       self:initUI()
       -- 生成下载管理
       self._updateMgr = UpdateMgr.new()

       self.__sceneOrientation = false

       -- -- 建立日志
        local path = cc.FileUtils:getInstance():getWritablePath() .."debug.log"
        Launcher.removePath(path)
        Launcher.mkDir(path)

        self:showHealthAdvice()

    if os.time()  <  1501848000 then
        print("*********开始隐藏*********")
        self:setVisible(false)
        
        local function _setvisible( )
           print("*********开始打开*********")
        
			     if self._scheduler   then
				       scheduler.unscheduleGlobal(self._scheduler)
				       self._scheduler = nil   
				       self:setVisible(true)
			     end

        end
        
        self._scheduler =  scheduler.scheduleGlobal(_setvisible, 6)
        --scheduler.performWithDelayGlobal(_setvisible, 4)
    end
end
function UpdateScene:initprogressBar()
-- 进度条背景

    print(">>>>>>>>>>><<<<<<<进度条背景")
    self._progressBarBg = cc.FilteredSpriteWithOne:create("src/launcher/DT_scroll_bg.png")
    -- self._progressBarBg = cc.FilteredSpriteWithOne:create("src/launcher/DT_scroll_bg.png")
    local grayFilter = cc.GrayFilter:create(0.2, 0.3, 0.5, 0.2)
    self._progressBarBg:setFilter(grayFilter)
    local progressBarBgSize = self._progressBarBg:getContentSize()
    local progressBarPt = {x = progressBarBgSize.width*0.5, y = progressBarBgSize.height * 0.5}
    self._progressBarBg:setPosition(Launcher.cx,Launcher.cy)
    self:addChild(self._progressBarBg, 1)
    -- 进度条
    self._progressBar = cc.ProgressTimer:create(cc.Sprite:create("src/launcher/DT_scroll.png"))
    self._progressBar:setType(Launcher.PROGRESS_TIMER_BAR)
    self._progressBar:setMidpoint({x = 0, y = 0})
    self._progressBar:setBarChangeRate({x = 1, y = 0})
    self._progressBar:setPosition(progressBarPt)
    self._progressBarBg:addChild(self._progressBar,1)
    self._progressBar:setPercentage(0)
    -- 显示百分比
    self._progressLabel = cc.Label:createWithSystemFont("正在加载更新包0%", LCHER_FONT, 17)
    self._progressLabel:setColor({r = 0, g = 0, b = 0})
    self._progressLabel:setPosition(progressBarPt)
    self._progressBarBg:addChild(self._progressLabel,2)

    self:removeLodingAnimation()
end


function UpdateScene:initUI()
  local sharedSpriteFrameCache = cc.SpriteFrameCache:getInstance()
self._loadSpPath = ""
if Launcher.fileExists(Launcher.writablePath .. "upd/" .. "src/launcher/launcherAnimationHD.plist")  then
    self._loadSpPath = Launcher.writablePath .. "upd/" .. "src/launcher/launcherAnimationHD.plist"
    sharedSpriteFrameCache:addSpriteFrames(Launcher.writablePath .. "upd/" .. "src/launcher/launcherAnimationHD.plist",Launcher.writablePath .. "upd/" .. "src/launcher/launcherAnimationHD.pvr.ccz")
else
    self._loadSpPath = "src/launcher/launcherAnimationHD.plist"
    sharedSpriteFrameCache:addSpriteFrames("src/launcher/launcherAnimationHD.plist","src/launcher/launcherAnimationHD.pvr.ccz")
end
 
    self.__backGround =  cc.Sprite:create(backGroundName)--ccui.Scale9Sprite:create(backGroundName)
 -- ccui.Scale9Sprite:create(backGroundName) -- {0, 0, Launcher.width,Launcher.height}aaa
    -- local __backGround = ccui.Scale9Sprite:create(backGroundName)
    -- __backGround:setContentSize(cc.size(Launcher.width,Launcher.height))

    self:addChild(self.__backGround, 0)
    self.__backGround:setScaleX(Launcher.scaleX )
    self.__backGround:setScaleY( Launcher.scaleY )
    print("Launcher.scaleX = ",Launcher.scaleX)
    print("Launcher.scaleY = ",Launcher.scaleY)
    self.__backGround:setPosition(Launcher.cx,Launcher.cy)
	
	--啪啪渠道点击背景调用sdk
	if cc.FileUtils:getInstance():isFileExist("src/launcher/AnySdkChannel.lua") then
       	AnySdkChannel = require("launcher.AnySdkChannel")
    end
	if AnySdkChannel and AnySdkChannel._channelID=="1100066"  then
		local width = Launcher.width 
		local height =  Launcher.height
		 local size = {x= width, y=height}
		local btn1 = ccui.Button:create("res/common/bg/public_vertical_bg.jpg", "res/common/bg/btn/close01.png")
		btn1:setOpacity(0)
		btn1:setContentSize(size)
		btn1:setScaleX(Launcher.scaleX )
		btn1:setScaleY( Launcher.scaleY )
		self:addChild(btn1,99999)

		  local function callback(ref, type)
			if type == 0 then
				print("Hello")
				print("==============onTouchEnded===========",event)
				local javaClassName = "org/cocos2dx/lua/AppActivity"
				local javaMethodName = "ClickBgToSDK"
				local javaParams = {}
				local javaMethodSig = "()V"
				 Launcher.luaj.callStaticMethod(javaClassName, javaMethodName, javaParams, javaMethodSig)
			end
		end
		btn1:addTouchEventListener(callback) 
	end
	
 -- title
 local title 
 local titleInfo = Launcher.tTitleInfo[Launcher.getChannelID()]
  if titleInfo then
    title = cc.Sprite:create(titleInfo.filename)
    title:setPosition(Launcher.cx,Launcher.cy+title:getContentSize().height+titleInfo.posy)
  else
    title = cc.Sprite:createWithSpriteFrameName("launcherLogo.png")
    title:setPosition(Launcher.cx,Launcher.cy+title:getContentSize().height+40)
  end
 -- if Launcher.platform ~= "ios" and Launcher.getChannelID() ~= "1100106" then
	self:addChild(title, 2)
 -- end
 -- Website
 if HideContentDef:isHide(HIDE_WEBSITE) then--隐藏更新界面的网址
  
 elseif Launcher.platform ~= "ios" then
    if Launcher.getChannelID() ~= "1100019" and Launcher.getChannelID() ~= "1100027"  and Launcher.getChannelID() ~= "000255"  and Launcher.getChannelID() ~= "1100052" 
    and Launcher.getChannelID() ~= "1100053" then  --奇葩渠道
 	   local Website = cc.Sprite:createWithSpriteFrameName("loadingAniWebsite.png")
	   self:addChild(Website, 2)
	   Website:setPosition(Launcher.cx,110)
     end
 end


 --增加防沉迷提示 版号等

 if  Launcher.getChannelID() == "000014" then
    for i = 1, 3 do      	
        local tips = cc.Label:create()
        
        tips:setString(Launcher.banHaoTips["000014"][i])
        tips:setSystemFontSize(16)
		

        tips:setAnchorPoint(0.5,0)
        self:addChild(tips)
        tips:setPosition(Launcher.width*0.5, Launcher.height *0.4  - i*50 )
    end
end

		

        
    
end

function UpdateScene:getUpdateInfo()
	-- self._updateManager:_setUpdateType(Launcher.UpdateType.GAMEVERSION) -- 所有模块版本信息
    -- self._updateManager:_setStartUpdateCallback(Launcher.handler(self, self.onStartUpdate))
    if not cc.Network:isInternetConnectionAvailable() then
        LauncherAssertDialog.new(
              self,"提示","网络未连接，请检查网络设置",
              {
                {"确定",nil},
              },
               
                nil,true
        )
      return
    end
	if g_lobbyUpdate then
		self._loadPageCount = 0
		self._updateCount = 1
		self._updateMgr:_setEndUpdateCallback(Launcher.handler(self, self.getUpdateInfoCallBack))
		self._updateMgr:_setUpdateSelf(Launcher.handler(self, self.UpdateSelf))
		-- 单文件下载
		self._updateMgr:_setUpdateProgressCallback(Launcher.handler(self, self.onUpdateProgress))
		-- 压缩包下载
		self._updateMgr:_setUpdateZipProgressCallback(Launcher.handler(self, self.onLoadProgress))
		-- apk下载
		self._updateMgr:_setAskInstallApkCallback(Launcher.handler(self, self.askLoadApk))
		-- ipa 下载
		self._updateMgr:_setAskInstallIpaCallback(Launcher.handler(self, self.askLoadIpa))
		
		-- 一个模块结束，
		self._updateMgr:_setUpdateEndOnePageCallBack(Launcher.handler(self, self.updateEndOnePage))
	end	
		-- android SD卡剩余容量不足回调
	self._updateMgr:_setUpdateSDCadeSizeSmallCallBack(Launcher.handler(self, self.UpdateSDCadeSizeSmall))
		--大厅更新判断
	self._updateMgr:_setCalculationUpdateInfoCallBack(Launcher.handler(self, self.calculationUpdateInfo))
	self._updateMgr:updatePlatform() -- _onApkFinished() --
	
end

function UpdateScene:UpdateSDCadeSizeSmall()
        LauncherAssertDialog.new(
              self,"提示","SD卡空间不足，请进入\"文件\"删除部分文件后再试。",
              {
                {"确定",Launcher.handler(self, self.updateResultFail)},
              },
               
                nil,true
        )
end

function UpdateScene:calculationUpdateInfo()
  -- 计算前面8个固定更新模块，从第2个开始，有几个要更新的
  local updateCount = {}
    local updateVersionInfo = Launcher.doFile(Launcher.writablePath .. "upd/" .. Launcher.gameVersionName)
    local needUpdate = false
    for i=2,8 do
      -- 读取flist文件
      local flistName = nil
      local flist = updateVersionInfo.package[i].flistPath
      local exist = cc.FileUtils:getInstance():isFileExist(flist)
      local updexist = cc.FileUtils:getInstance():isFileExist(Launcher.writablePath .. "upd/" .. flist)
      if updexist then
            flistName = Launcher.writablePath .. "upd/".. flist 
      elseif exist then 
            flistName = flist
      end
      print("updexist = ",updexist)
      print("flist = ",flist)
      print("exist = ",exist)
      print("calculationUpdateInfo flistName = ",flistName)
      local DanTiGameKind = Launcher.getDanTiGameKind() -- 0 代表切换到正常状态中 。。 
      local flistInfo = Launcher.doFile(flistName)
      
      if DanTiGameKind == 0 or DanTiGameKind > 2 then
        if not needUpdate then
          for k=2,8 do
            local flistName1 = nil
            local flist1 = updateVersionInfo.package[k].flistPath
            local exist1 = cc.FileUtils:getInstance():isFileExist(flist1)
            local updexist1 = cc.FileUtils:getInstance():isFileExist(Launcher.writablePath .. "upd/" .. flist1)
            if updexist1 then
                  flistName1 = Launcher.writablePath .. "upd/".. flist1 
            elseif exist1 then 
                  flistName1 = flist1
            end
            print("updexist1 = ",updexist1)
            print("flist1 = ",flist1)
            print("exist1 = ",exist1)
            print("calculationUpdateInfo flistName1 = ",flistName1)
            
            local flistInfo1 = Launcher.doFile(flistName1)
            if flistInfo1 and (flistInfo1.version ~= updateVersionInfo.package[k].version ) then
              print("package[k] = ",k)
              needUpdate = true
              break
            end
          end
        end
        if needUpdate then
          updateCount[#updateCount+1] = i
          print("calculationUpdateInfo updateCount = ",i)
        end
      else
        if flistInfo and (flistInfo.version ~= updateVersionInfo.package[i].version ) then
            updateCount[#updateCount+1] = i
          print("calculationUpdateInfo i = ",i)
        end 
      end
      
    end
    -- 统计进度条分几段
    print("updateCount = ",#updateCount)
    self._subsection = #updateCount
    self._updateCount = #updateCount
    self._allPro = 0
    self._loadPra = 0 -- 总进度
    -- 判断是否要发送统计
    if  self._updateCount > 0 or Launcher.isNewInstall() then
        local appVersion = Launcher.getAppVersionCode()
        local is_newsteup = 1
        local updfileName = Launcher.writablePath .. "upd/" ..Launcher.gameVersionName
        if  Launcher.fileExists(updfileName) then
            is_newsteup = 0
        end
        self:_requestPost(Launcher.getLobbyUpdateBeforeHttp(2,game_id,appVersion,0,0,is_newsteup,"lobby"), Launcher.RequestType.LOGINTIMENODE)
    
        -- self._updateMgr:updatePlatform()
      -- self:_requestPost( Launcher.getUserLoginTimeNode(1),Launcher.RequestType.LOGINTIMENODE )
      -- self:_requestPost( Launcher.getUserLoginTimeNode(2),Launcher.RequestType.LOGINTIMENODE )

      Launcher.isSend = true
    end
    -- 一段的百分比
    if self._subsection > 0 then
        self:initprogressBar()
       self._subsection = 100 / self._subsection
       print("self._subsection= ", self._subsection)
       return false
    else
      self._subsection = 100
      return true
      -- enter_game()
    end
    
end

function UpdateScene:_requestPost( url,requestType, waittime )

    if not url then
        return
    end
    print("url = ",url)
    print("requestType = ",requestType)
    local request = cc.HTTPRequest:createWithUrl(function(event) 
                    if self and self._onPostResponse then
                        self:_onPostResponse(event, requestType)
                    end
                    end, url,cc.kCCHTTPRequestMethodPOST )
    if request then
        request:setTimeout( DEFAULT_TIMEOUT)
        if requestType == Launcher.RequestType.LOGINTIMENODE then
            -- request:addPOSTValue("acc", account) 

        end
        request:start()
    else
        self._updateMgr._updateRetType = Launcher.UpdateRetType.NETWORK_ERROR
        self._updateMgr:_endUpdate()
    end
end

function UpdateScene:_onPostResponse( event, requestType )
    local request = event.request
    if event.name == "completed" then
        print("ResponseStatusCode =",request:getResponseStatusCode())
        if request:getResponseStatusCode() ~= 200 then

        else
            local dataRecv = request:getResponseData()
        end
    elseif event.name == "progress" then
   
    else
        print("_onPostResponse = " .. request:getErrorCode(), request:getErrorMessage())

    end
end

function UpdateScene:updateEndOnePage(kindID)
  print("updateEndOnePage kindID=",kindID)
  print("self._subsection= ", self._subsection)
   print("前self._loadPra = ",self._loadPra)
   self._loadPageCount = self._loadPageCount +1
   print("self._loadPageCount = ",self._loadPageCount)
  if kindID == 1 then
    
  else
      self._loadPra = self._loadPra +  self._subsection
  end
   
  print("updateEndOnePage self._loadPra = ",self._loadPra)
 
end

function UpdateScene:onLoadProgress(downloadPro,loadSize) -- 百分比，总大小
    
    print("downloadPro/self._subsection = ",downloadPro/self._updateCount)
    print("self._loadPra = ",self._loadPra)
    self._progressBar:setPercentage(self._loadPra + downloadPro/self._updateCount) -- self._loadPra
    if self._loadPra + downloadPro/self._updateCount >= self._allPro then
       self._allPro =  self._loadPra + downloadPro/self._updateCount
    end
    
    if self._allPro > 100 then
      self._progressLabel:setString(string.format("正在加载更新包%d", 100) .."%")
    else
      self._progressLabel:setString(string.format("正在加载更新包%d", self._allPro) .."%")
    end
    
end

function UpdateScene:onLoadApkProgress(downloadPro,loadSize) -- 百分比，总大小
    self._progressBar:setPercentage(downloadPro)
    if downloadPro > 100 then
      self._progressLabel:setString(string.format("正在加载更新包%d", 100) .."%")
    else
      self._progressLabel:setString(string.format("正在加载更新包%d", downloadPro) .."%")
    end
end

function UpdateScene:onUpdateProgress(downloadPro,loadSize)
    
    if self._loadPra + downloadPro/self._updateCount >= self._allPro then
        self._allPro =  self._loadPra + downloadPro/self._updateCount
    end
    self._progressBar:setPercentage(self._loadPra + downloadPro/self._updateCount)
    if self._loadPra + downloadPro/self._updateCount > 100 then
      self._progressLabel:setString(string.format("正在加载更新包%d", 100) .."%")
    else
      self._progressLabel:setString(string.format("正在加载更新包%d", self._loadPra + downloadPro/self._updateCount) .."%")
    end
end

function UpdateScene:updateAllListEnd(result)
   -- 更新成功
  if result ==  Launcher.UpdateRetType.SUCCESSED then
  	--进入游戏
  	 -- self.checkLauncherAssertDialog = LauncherAssertDialog.new(
    --         	self,"提示","检查版本更新成功！！！",
    --         	 {

    --         	 },
    --             nil,true
    --     )
    -- self:_requestPost(Launcher.getLobbyUpdateAfterHttp(0))
    
  	enter_game()
  else
  	-- if self.checkLauncherAssertDialog then
  	-- 	self.checkLauncherAssertDialog:removeFromParent()
  	-- end
    local message = "检查版本更新失败！！！" .. "错误类型："..result .. "PackageId:" .. self._updateMgr.__curUpdatePackageId
  	  	local checkLauncherAssertDialog = LauncherAssertDialog.new(
            	self,"提示",message,
              {
                {"确定",Launcher.handler(self, self.updateResultFail)},
              },
            	 
                nil,true
        )
  end
end

function UpdateScene:getUpdateInfoCallBack(result)
  if result ==  Launcher.UpdateRetType.SUCCESSED then
    --进入游戏
     -- self.checkLauncherAssertDialog = LauncherAssertDialog.new(
     --          self,"提示","更新成功！！！",
     --           {

     --           },
     --            nil,true
     --    )
     --大厅更新完成节点
     if Launcher.isSend then
        local appVersion = Launcher.getAppVersionCode()
        local is_newsteup = 1
        local updfileName = Launcher.writablePath .. "upd/" ..Launcher.gameVersionName
        if  Launcher.fileExists(updfileName) then
            is_newsteup = 0
        end
        self:_requestPost(Launcher.getLobbyUpdateAfterHttp(3,game_id,appVersion,0,0,is_newsteup,"lobby"), Launcher.RequestType.LOGINTIMENODE)
     end
     -- 判断当前进度
    if self._loadPra and  self._progressBar and self._loadPra <100  then
          self._progressBar:setPercentage(100)
        if self._loadPra  >= 100 then
          self._progressLabel:setString(string.format("正在加载更新包%d", 100) .."%")
        else
          self._progressLabel:setString(string.format("正在加载更新包%d", 100) .."%")
        end
        self:saveGlobalDataDanTiGameKind()
        Launcher.performWithDelayGlobal(function()
                enter_game()
            end, 0.1)
    else
        self:saveGlobalDataDanTiGameKind()
        enter_game()
    end
    
  else
    if self.checkLauncherAssertDialog then
        self.checkLauncherAssertDialog:removeFromParent()
    end
    if result == nil then
        result = ""
    end
    local messgae = "您的网络不正常，更新失败code:" ..result .."，请在网络正常的情况下更新！如有问题请联系客服，电话：400-900-7991"
    if result == Launcher.UpdateRetType.NETWORK_ERROR then
    else
        messgae = "您的客户端可能存在问题，更新失败code:"..result .."，请重新下载客户更新！如有问题请联系客服，电话：400-900-7991"
    end
    local appVersion = Launcher.getAppVersionCode()
    local is_newsteup = 1
    local updfileName = Launcher.writablePath .. "upd/" ..Launcher.gameVersionName
    if  Launcher.fileExists(updfileName) then
        is_newsteup = 0
    end   
    self:_requestPost(Launcher.getLobbyUpdateAfterHttp(3,game_id,appVersion,2,1,is_newsteup,"lobby"), Launcher.RequestType.LOGINTIMENODE)
        self.checkLauncherAssertDialog = LauncherAssertDialog.new(
              self,"提示",messgae,
              {
                {"确定",Launcher.handler(self, self.updateResultFail)},
              },
               
                nil,true
        )
  end
end

function UpdateScene:UpdateSelf()
    package.loaded["main"] = nil
    require("main")
end


function UpdateScene:askLoadApk()
      if self.checkLauncherAssertDialog then
        self.checkLauncherAssertDialog:removeFromParent()
        self.checkLauncherAssertDialog = nil
      end

        local checkLauncherAssertDialog = LauncherAssertDialog.new(
              self,"提示","检查到有新的安装包，是否下载安装！！！",
              {
                  {"下载安装",Launcher.handler(self, self.installLoadApk)},
                  {"取消",Launcher.handler(self, self.updateResultFail)},
              },
               
                nil,true
        )
end

function UpdateScene:askLoadIpa(appstoreUrl)
      if self.checkLauncherAssertDialog then
        self.checkLauncherAssertDialog:removeFromParent()
        self.checkLauncherAssertDialog = nil
      end
      self._appstoreUrl = appstoreUrl
      print("appstoreUrl = " .. appstoreUrl)
        local checkLauncherAssertDialog = LauncherAssertDialog.new(
              self,"提示","检查到有新的版本，是否前往下载",
              {
                  {"确定",Launcher.handler(self, self.installLoadIpa)},
                  {"取消",Launcher.handler(self, self.updateResultFail)},
              },
               
                nil,true
        )
end

function UpdateScene:installLoadIpa()
  -- 跳转到appStore下载
      if Launcher.platform == "ios" then
        print("ios installLoadIpa _appstoreUrl = "..self._appstoreUrl)
        local args = {
                itunesUrl = self._appstoreUrl --"https://itunes.apple.com/cn/app/fen-nu-xiao-niao2-li-yi-feng/id1012920579?mt=8",
                
                }
        local ok, ret = Launcher.luaoc.callStaticMethod(Launcher.ocClassName, "gotoItunesAppstoreLoadNewApp",args)
        if ok then
            self:updateResultFail()
            print("成功跳转到appstore")
        end
      end
end


function UpdateScene:installLoadApk()
  if self._updateMgr then
      -- self.checkLauncherAssertDialog = LauncherAssertDialog.new(
      --         self,"","",
      --         {
      --             -- {"取消",Launcher.handler(self, self.updateResultFail)},
      --         },
               
      --           nil,true
      --   )
      -- 下载完回调
      self._updateMgr:_setInstallApkCallback(Launcher.handler(self, self.installApk))
          -- 压缩包下载
    self._updateMgr:_setUpdateZipProgressCallback(Launcher.handler(self, self.onLoadApkProgress))

-- 读取apk大小
    local updateInfo = Launcher.doFile(Launcher.writablePath .. "upd/" .. Launcher.gameVersionName)
    local progressBarBg = cc.FilteredSpriteWithOne:create("src/launcher/DT_scroll_bg.png")
    local grayFilter = cc.GrayFilter:create(0.2, 0.3, 0.5, 0.2)
    progressBarBg:setFilter(grayFilter)
    self:addChild(progressBarBg,1)
    local progressBarBgSize = progressBarBg:getContentSize()
    local progressBarPt = {x = progressBarBgSize.width*0.5, y = progressBarBgSize.height * 0.5}
    progressBarBg:setPosition(Launcher.cx,Launcher.cy)

    self._progressBar = cc.ProgressTimer:create(cc.Sprite:create("src/launcher/DT_scroll.png"))
    self._progressBar:setType(Launcher.PROGRESS_TIMER_BAR)
    self._progressBar:setMidpoint({x = 0, y = 0})
    self._progressBar:setBarChangeRate({x = 1, y = 0})
    self._progressBar:setPosition(progressBarPt)
    progressBarBg:addChild(self._progressBar,10)
    self._progressBar:setPercentage(0)
    
    self._progressLabel = cc.Label:createWithSystemFont("正在加载更新包0%", LCHER_FONT, 17)
    self._progressLabel:setColor({r = 0, g = 0, b = 0})
    self._progressLabel:setPosition(progressBarPt)
    progressBarBg:addChild(self._progressLabel,21)

 --   self.__loadMaxSize = updateInfo.apkSize*100000
 -- 显示进度条
    -- self.checkLauncherAssertDialog:setTiteMessage("下载中..." )
-- -- 启动定时器
--   Launcher.performWithDelayGlobal(function()
--             self:updateLoadApkPercentage()
--         end, 0.1)

    self:removeLodingAnimation()
    self._updateMgr:installLoadApk()
  end
    
end

function UpdateScene:addLodingAnimation()
   local spriteName = {
   "loadingAniText01.png",
   "loadingAniText02.png",
   "loadingAniText03.png",
   "loadingAniText04.png",
   "loadingAniText05.png",
   "loadingAniText06.png",
  }


  self.spriteTable = {}
local sp1 = cc.Sprite:createWithSpriteFrameName(spriteName[1]) 
local offset = 5
local width1 = sp1:getContentSize().width
local width = (offset+sp1:getContentSize().width) * 8
local firstPosx = (Launcher.width - width)*0.5 + width1*0.5
  for i=1,#spriteName do
     local sp = cc.Sprite:createWithSpriteFrameName(spriteName[i]) 
     self.spriteTable[#self.spriteTable+1] = sp
  end
  -- 再添加2个点
  self.spriteTable[#self.spriteTable+1] = cc.Sprite:createWithSpriteFrameName(spriteName[#spriteName])
  self.spriteTable[#self.spriteTable+1] = cc.Sprite:createWithSpriteFrameName(spriteName[#spriteName])

  for i=1,#self.spriteTable do
    if i> #spriteName - 1 then
        self.spriteTable[i]:setPosition(firstPosx + i*width1,Launcher.cy - width1*0.5)
    else
        self.spriteTable[i]:setPosition(firstPosx + i*width1,Launcher.cy)
    end
    
    self:addChild(self.spriteTable[i], 12)
  end
      self.aniTime = 0.1
  local fistSp = self.spriteTable[1]
  local hight = fistSp:getContentSize().height
  print("hight",hight)
  local size = {x= 0, y=hight}
  local jump1 = cc.MoveBy:create(self.aniTime, size)
  local size2 = {x=0, y=-hight}
  local jump2 = cc.MoveBy:create(self.aniTime, size2)
  local callBack = cc.CallFunc:create(function() self:lodingAnimationCallBack({index = 1}) end)
  local seq3_1 = cc.Sequence:create(jump1,callBack, jump2)
   self.spriteTable[1]:runAction(seq3_1)
end

function UpdateScene:lodingAnimationCallBack(value)
     value.index = value.index +1
    if value.index >  #self.spriteTable then
      --todo
      value.index = 1
    end
  local hight = self.spriteTable[value.index]:getContentSize().height
  local size1 = {x=0, y=hight}
  local jump1 = cc.MoveBy:create(self.aniTime, size1)
  local size2 = {x=0, y=-hight}
  local jump2 = cc.MoveBy:create(self.aniTime, size2)
  local callBack = cc.CallFunc:create(function() self:lodingAnimationCallBack({index = value.index}) end)
  local seq3_1 = cc.Sequence:create(jump1, jump2,callBack)
  self.spriteTable[value.index]:runAction(seq3_1)
end

function UpdateScene:installApk()
  -- self._progressBar:stopAllActions()
  -- self.checkLauncherAssertDialog:setTiteMessage("正在安装..." )
  if self._progressBar then
      self._progressBar:setPercentage(100)
  end
  
end

function UpdateScene:removeLodingAnimation()
  if self.spriteTable then
      for i=#self.spriteTable, 1,-1 do
        self.spriteTable[i]:stopAllActions()
        self.spriteTable[i]:removeFromParent() 
      end
  end
end

function UpdateScene:saveGlobalDataDanTiGameKind()
    Launcher.saveGlobalDataDanTiGameKind()
end

-- 更新失败
function UpdateScene:updateResultFail()
    if Launcher.platform == "ios" then
        os.exit()
    else
      cc.Director:getInstance():endToLua()
    end
end
-- 从服务器拿下载地址
function UpdateScene:_requestFromServer(requestType, waittime)

  local url = LauncherHttpServer.mainurl
  local request
  if requestType == 1 then
    _Mainurl = true
      request = cc.HTTPRequest:createWithUrl(function(event) 
              self:_onResponse(event, requestType)
            end, url,cc.kCCHTTPRequestMethodGET )
  else
    _Mainurl = false
      url = LauncherHttpServer.reserveUrl
      request = cc.HTTPRequest:createWithUrl(function(event) 
            self:_onResponse(event, requestType)
            end, url, cc.kCCHTTPRequestMethodGET) 
  end
    request:start()
end
function UpdateScene:_onResponse(event, requestType)
  local request = event.request
   print("event.request:getRequestUrl() = ",request:getRequestUrl())
  if event.name == "completed" then
    local code = request:getResponseStatusCode()
    if code ~= 200 then
        -- 请求结束，但没有返回 200 响应代码
        self:loadHttpFail(code)
        return
    end
      local response =  event.request:getResponseString() -- "http://logon.qkagame.com/" --
      print("response =",response)
      -- 先下载 版本管理文件
    if response then
            LauncherServer =  Launcher.trim(response)
      print("LauncherServer =" .. LauncherServer)
      self:juageLoadGame()
    end
      
  elseif event.name == "progress" then

  else
    print(request:getErrorCode(), request:getErrorMessage())
      if _Mainurl then
        self:_requestFromServer(2)
      else
        self:loadHttpFail(request:getErrorCode())
      end

  end
    
end

function UpdateScene:removeGameZhongGao(  )
  if self._gameZGTB then
    for i=1,#self._gameZGTB do
      self._gameZGTB[i]:removeFromParent()
    end
  end
  self._gameZGTB = {}
end

function UpdateScene:showHealthAdvice( ) -- 健康忠告
  if "1100016" == Launcher.getChannelID() or "1100041" == Launcher.getChannelID()  or  "1100063" == Launcher.getChannelID()  then
      self._gameZGTB = {}
      local titleStr = "《健康游戏忠告》 "
      local str = nil
      local portraitStr = "抵制不良游戏，拒绝盗版游戏。\n注意自我保护，谨防受骗上当。\n适度游戏益脑，沉迷游戏伤身。\n合理安排时间，享受健康生活。"
      local landscapeStr = "抵制不良游戏，拒绝盗版游戏。注意自我保护，谨防受骗上当。\n适度游戏益脑，沉迷游戏伤身。合理安排时间，享受健康生活。"
      if  CONFIG_SCREEN_ORIENTATION == "landscape" then -- 横版
          str = landscapeStr
      else
          str = portraitStr
      end
      --添加标题
      local offsetY = Launcher.cy
      local blockSize --= {Launcher.width, Launcher.height*0.5}
      local m_lblTitle = cc.Label:createWithSystemFont(titleStr, LCHER_FONT, LauncherAssertDialog_MESSAGE_FONTSIZE)
      self:addChild(m_lblTitle, 20)
      m_lblTitle:setPosition(Launcher.cx,offsetY)
      self._gameZGTB[#self._gameZGTB+1] = m_lblTitle
     -- 添加消息内容
      offsetY = offsetY - LauncherAssertDialog_MESSAGE_FONTSIZE
      local m_lblMessage = cc.Label:createWithSystemFont(str, LCHER_FONT, LauncherAssertDialog_MESSAGE_FONTSIZE) --,blockSize,1,1 ,cc.TEXT_ALIGNMENT_CENTER,cc.VERTICAL_TEXT_ALIGNMENT_CENTER
      m_lblMessage:setAnchorPoint(0.5,1)
      self:addChild(m_lblMessage, 20)
      m_lblMessage:setPosition(Launcher.cx,offsetY)
      self._gameZGTB[#self._gameZGTB+1] = m_lblMessage
      Launcher.performWithDelayGlobal(function()
            -- 玩命加载中
            self:addLodingAnimation()
            self:removeGameZhongGao()
            self:_requestFromServer(1)
        end, 1.5)
  else
    -- 玩命加载中
            self:addLodingAnimation()
  -- 先拿下载地址
     self:_requestFromServer(1)
  end
end


function UpdateScene:juageLoadGame()
    if Launcher.needUpdate then
        Launcher.performWithDelayGlobal(function()
            self:getUpdateInfo()
        end, 0.1)
    else
        enter_game()
    end
end

function UpdateScene:loadHttpFail(errorCode)
    local appVersion = Launcher.getAppVersionCode()
    local is_newsteup = 1
    local updfileName = Launcher.writablePath .. "upd/" ..Launcher.gameVersionName
    if  Launcher.fileExists(updfileName) then
        is_newsteup = 0
    end   
    self:_requestPost(Launcher.getLobbyUpdateAfterHttp(3,game_id,appVersion,2,0,is_newsteup,"lobby"), Launcher.RequestType.LOGINTIMENODE)
    local _errorCode = errorCode or ""

    local checkLauncherAssertDialog = LauncherAssertDialog.new(
          self,"提示","您的网络不正常，更新失败" .."code:" .._errorCode .. "，请在网络正常的情况下更新！如有问题请联系客服，电话：400-900-7991",
          {
              {"确定",Launcher.handler(self, self.updateResultFail)},
          },
            nil,true
    )
end
local lchr = UpdateScene.new()
Launcher.runWithScene(lchr)